include qlib.inc  ;setup
include file.inc
include string.inc
include private.inc

.code

sscanf proc,buf:dword,format:dword,vars:vararg
  ;ADDED in Ver 1.1
  ;allowed % : s,d,w,b,c
  ;allowed mods: H,B,S  (sign is ignored cause str2num always checks)
  ; % [[S,H,B](b,w,d)],[c],[s]
  ; S=signed decimal \
  ; H=hex output      = default is decimal
  ; B=binary output  /  
  ; (b=byte,w=word,d=dword,c=char)
  ; prefixes ignored with char
  pushad
  mov esi,format
  mov edi,buf
  add ebp,16     ;ebp=>varargs    : EBP, ret, buf, format, varargs

@@top:
  mov al,[esi]
  cmp al,0
  jz __end
  cmp al,'%'
  jz @@per
@@per1:
  inc esi
  inc edi
  jmp @@top
@@per:                            ; % is use
  inc esi
  mov al,[esi]

  .if al=='s'
    inc esi
    callp strcpy,[ebp],edi
    callp strlen,edi
    add edi,eax
    inc edi  ;there better be more stuff after the 0 if you still have more
             ;fields in fill in
    add ebp,4
    jmp @@top
  .endif
  xor bl,bl   ;bl=0 norm.
@@:
  .if al=='S'   ;just ignore
    inc esi
    mov al,[esi]
    jmp @@start
  .endif
  .if al=='H'
    mov bl,2    ;bl=2 hex output
    inc esi
    mov al,[esi]
    jmp @@start
  .endif
  .if al=='B'
    mov bl,3   ;bl=3 binary output
    inc esi
    mov al,[esi]
  .endif
@@start:
  cmp al,0
  jz __end  ;not enough stuff!

  inc esi
  cmp al,'b'
  jz @@perb
  cmp al,'w'
  jz @@perw
  cmp al,'d'
  jz @@perd
  cmp al,'c'
  jz @@perc
  jmp @@per1 ;ignore % and go on
@@perb:
  cmp bl,2
  jb @@bn  ;byte norm.
  jz @@bh  ;byte hexed
;binary
  invoke str2num_b,edi
  mov ecx,[ebp]
  mov [ecx],al
  jmp addstr
@@bn:
  invoke str2num,edi
  mov ecx,[ebp]
  mov [ecx],al
  jmp addstr
@@bh:
  invoke str2num_h,edi
  mov ecx,[ebp]
  mov [ecx],al
  jmp addstr
@@perw:
  cmp bl,2
  jb @@wn  ;byte norm.
  jz @@wh  ;byte hexed
;binary
  invoke str2num_b,edi
  mov ecx,[ebp]
  mov [ecx],ax
  jmp addstr
@@wn:
  invoke str2num,edi
  mov ecx,[ebp]
  mov [ecx],ax
  jmp addstr
@@wh:
  invoke str2num_h,edi
  mov ecx,[ebp]
  mov [ecx],ax
  jmp addstr
@@perd:
  cmp bl,2
  jb @@dn  ;byte norm.
  jz @@dh  ;byte hexed
;binary
  invoke str2num_b,edi
  mov ecx,[ebp]
  mov [ecx],eax
  jmp addstr
@@dn:
  invoke str2num,edi
  mov ecx,[ebp]
  mov [ecx],eax
  jmp addstr
@@dh:
  invoke str2num_h,edi
  mov ecx,[ebp]
  mov [ecx],eax
  jmp addstr
@@perc:
  mov ecx,[ebp]
  mov al,[edi]
  mov [ecx],al
  inc edi
  add ebp,4    ;no byte pushes possible
  jmp @@top
__end:
  popad
  ret
addstr:
  add ebp,4      ;move to next var.
  add edi,_str2num_siz_  ;size of last str2num call
  jmp @@top
sscanf endp

end

