; A simple test : showing off GUI... uhh...
include qlib.inc
include file.inc
include gui.inc
include key.inc
include video.inc
include string.inc
include error.asm

.data
  gui_config gui_cfg <>  ;font
  tvid dd 0
      ; windows are setup as follows
      ;            r=reserved  ?=ignored
      ;button = ;r,r,id,next,x1,y1,x2,y2,tx,ty,TEXT
      ;flist  = ;r,r,id,next,x1,y1,? ,y2,r,r,mask,current dir  
      ;str    = ;r,r,id,next,x1,y1,x2,? ,tx,ty,TEXT  
      ; all ID's must be unique
  ;Windows below
  w1 label byte
  w1b1 gui_button <,,1,w1b2,8,8,28,20       ,2,2,"=>">
  w1b2 gui_button <,,2,0   ,8,20,76,32      ,2,2,"Increase">
  w2 label byte
  w2b1 gui_button <,,3,w2b2,500,8,520,20    ,2,2,"<=">
  w2b2 gui_button <,,4,0   ,500,20,568,32   ,2,2,"Decrease">
  w3 label byte
  w3b1 gui_button <,,5,w3b2,320,200,388,212 ,2,2,"EXIT">
  w3b2 gui_button <,,7,w3s1,390,200,458,212 ,2,2,"LOAD">
  w3s1 gui_str    <,,8,w3l1,320,180,428,192 ,2,2,'Filename'>
  w3l1 gui_flist  <,,6,0   ,320,220,0,400   ,,,"*.*",'D:\32\TEST'>

  number db 0  ;used to inc/dec thru buttons
  fn db 128 dup (?)

cursor label byte
  db 05,05,05,05,05,05,05,05,05,05,05,05,05,05,05,05
  db 05,03,03,03,03,03,03,03,03,03,03,03,03,03,05,00
  db 05,03,03,03,03,03,03,03,03,03,03,03,03,05,00,00
  db 05,03,03,03,03,03,03,03,03,03,03,03,05,00,00,00
  db 05,03,03,03,03,03,03,03,03,03,03,05,00,00,00,00
  db 05,03,03,03,03,03,03,03,03,03,05,00,00,00,00,00
  db 05,03,03,03,03,03,03,03,03,03,05,00,00,00,00,00
  db 05,03,03,03,03,03,03,03,03,03,03,05,00,00,00,00
  db 05,03,03,03,03,03,03,03,03,03,03,03,05,00,00,00
  db 05,03,03,03,03,03,03,03,03,03,03,03,03,05,00,00
  db 05,03,03,03,03,05,05,03,03,03,03,03,03,03,05,00
  db 05,03,03,03,05,00,00,05,03,03,03,03,03,03,03,05
  db 05,03,03,05,00,00,00,00,05,03,03,03,03,03,05,00
  db 05,03,05,00,00,00,00,00,00,05,03,03,03,05,00,00
  db 05,05,00,00,00,00,00,00,00,00,05,03,05,00,00,00
  db 05,00,00,00,00,00,00,00,00,00,00,05,00,00,00,00

.code

init proc
  mov eax,256+1  ;640x480x8bit
  call checkvbemode
  exit_on_error "Unable to setup VBE 2.0 video mode : 640x480x256"

  call setvbemode
  call mouse_init   ;if mouse_init is called after MODE is set the X/Y will
                    ;be setup automatically
  g_exit_on_error "Mouse not detected!"
  ;0-63
  callp setcol,0,0,0,0          ;black
  callp setcol,1,20,20,60       ;light blue
  callp setcol,2,0,0,63         ;blue
  callp setcol,3,0,0,32         ;dark blue
  callp setcol,4,50,50,50       ;grey
  callp setcol,5,63,63,63       ;white

  callp malloc,640*480
  g_exit_on_error "RAM"
  mov tvid,eax

  callp gset,eax

  callp mouse_setcursor,offset cursor,16,16,0,0

  callp gloadfnt,"norm.fnt"
  g_exit_on_error "Unable to load Font!"

  mov gui_config.font,eax
  callp gfntcolor,gui_config.font,5

  callp gui_init,offset gui_config
  g_exit_on_error "''gui_init'' failed."

  mov edi,tvid
  mov al,2
  mov ecx,640*480
  rep stosb

  callp gsetfnt,gui_config.font
  call v_copy

  ret
init endp

main proc
  call init

  callp gui_addlist,offset w1
  g_exit_on_error
  callp gui_addlist,offset w2
  g_exit_on_error
  callp gui_addlist,offset w3
  g_exit_on_error
  callp gui_filelist,6,1,1,1
  g_exit_on_error "''gui_filelist'' failed."
  callp gui_enablelist,5
  g_exit_on_error "''gui_enablelist'' failed."
  callp gui_enablelist,1
  g_exit_on_error "''gui_enablelist'' failed."
  call mouse_on
top:
  call getch
  .if al==27
    jmp exit_all
  .endif
  callp gboxfill,320,400,344,408,1
  callp gprintf,320,400,"%b",number
  callp gboxfill,320,440,600,448,1
  callp gprintf,320,440,"%s",offset w3l1.cd
  callp gui_update,1
  .if eax==1
    callp gui_disablelist,1
    g_exit_on_error "dis"
    callp gui_enablelist,3
    g_exit_on_error "en"
  .elseif eax==2
    inc number
  .elseif eax==3
    callp gui_disablelist,3
    g_exit_on_error
    callp gui_enablelist,1
    g_exit_on_error
  .elseif eax==4
    dec number
  .elseif eax==5
    jmp exit_all
  .elseif eax==6
    .if !bptr[edx]
      jmp top
    .endif
    mov al,[edx]
    mov bl,[edx+1]
    mov cl,[edx+2]
    .if al=='['
      mov edx,offset w3l1.cd
      mov [edx],bl
      mov [edx+1],cl
      mov bptr[edx+2],0
      callp gui_filelist,6,1,1,1
      callp gui_enable,6   ;re-enable to reprint it
      jmp top
    .endif
    .if (al=='\') && (bl=='.')
      .if cl=='.' ;\..
        mov ebx,offset w3l1.cd
        callp strlen,ebx
        add ebx,eax
        .if eax<=2
          ;there is a \.. entry in the root
          jmp top  ;ignore (this should never happen but can w/ subst and stuff)
        .endif
@@:
        .if !(bptr[ebx]=='\')
          dec ebx
          jmp @b
        .endif
        mov bptr[ebx],0
        callp gui_filelist,6,1,1,1
        callp gui_enable,6   ;re-enable to reprint it
        jmp top
      .else
        jmp top  ;\.
      .endif
    .elseif (al=='\')
      mov eax,offset w3l1.cd
      callp strcat,eax,edx
      callp gui_filelist,6,1,1,1
      callp gui_enable,6   ;re-enable to reprint it
      jmp top
    .endif
    ;; EDX = file selected!!!
    callp strcpy,offset w3s1.str1,edx
    callp gui_enable,8 ;reprint filename
  .elseif al==7
    ;LOAD file (this is just a test)
    callp strcpy,offset fn,offset w3l1.cd
    callp strcat,offset fn,"\\"
    callp strcat,offset fn,offset w3s1.str1
    callp gprintf,0,320,"File loaded: (this is just a test)"
    callp gboxfill,0,330,310,340,2
    callp gprintf,0,330,offset fn
  .elseif al==8
    ;file name has been edited
    ; I only want a filename in there (no path/drive) so remove them
    mov esi,offset w3s1.str1
    callp strlen,esi
    .if !eax
      jmp top
    .endif
    mov ecx,eax
    mov edi,esi
@@:
    lodsb
    .if (al=='\') || (al==':')
      mov edi,esi
    .endif
    dec ecx
    jnz @b
    callp strcpy,offset w3s1.str1,edi
    callp gui_enable,8  ;reprint it
  .endif
  jmp top
exit_all:
  call gui_uninit  ;calls mouse_off

  callp setgmode,3

  ret
main endp

end

